## GtkImage

GtkImage — A widget displaying an image

## Functions

void | gtk_image_get_icon_set ()
void | gtk_image_get_image ()
GdkPixbuf * | gtk_image_get_pixbuf ()
void | gtk_image_get_pixmap ()
void | gtk_image_get_stock ()
GdkPixbufAnimation * | gtk_image_get_animation ()
void | gtk_image_get_icon_name ()
void | gtk_image_get_gicon ()
GtkImageType | gtk_image_get_storage_type ()
GtkWidget * | gtk_image_new_from_icon_set ()
GtkWidget * | gtk_image_new_from_image ()
GtkWidget * | gtk_image_new_from_pixbuf ()
GtkWidget * | gtk_image_new_from_pixmap ()
GtkWidget * | gtk_image_new_from_stock ()
GtkWidget * | gtk_image_new_from_animation ()
GtkWidget * | gtk_image_new_from_icon_name ()
GtkWidget * | gtk_image_new_from_gicon ()
void | gtk_image_set_from_icon_set ()
void | gtk_image_set_from_image ()
void | gtk_image_set_from_pixbuf ()
void | gtk_image_set_from_pixmap ()
void | gtk_image_set_from_stock ()
void | gtk_image_set_from_animation ()
void | gtk_image_set_from_icon_name ()
void | gtk_image_set_from_gicon ()
void | gtk_image_clear ()
GtkWidget * | gtk_image_new ()
void | gtk_image_set ()
void | gtk_image_get ()
void | gtk_image_set_pixel_size ()
gint | gtk_image_get_pixel_size ()

## Properties

gchar * | file | Read / Write
GIcon * | gicon | Read / Write
gchar * | icon-name | Read / Write
GtkIconSet * | icon-set | Read / Write
gint | icon-size | Read / Write
GdkImage * | image | Read / Write
GdkPixmap * | mask | Read / Write
GdkPixbuf * | pixbuf | Read / Write
GdkPixbufAnimation * | pixbuf-animation | Read / Write
gint | pixel-size | Read / Write
GdkPixmap * | pixmap | Read / Write
gchar * | stock | Read / Write
GtkImageType | storage-type | Read

## Types and Values

struct | GtkImage
enum | GtkImageType
#define | gtk_image_new_from_file
#define | gtk_image_set_from_file

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkMisc
                        ╰── GtkImage

## Implemented Interfaces

GtkImage implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkImage widget displays an image. Various kinds of object can be displayed as an image; most typically, you would load a GdkPixbuf ("pixel buffer") from a file, and then display that. There's a convenience function to do this, `gtk_image_new_from_file()`, used as follows:

    1
    2

    GtkWidget *image;
    image = gtk_image_new_from_file ("myfile.png");

If the file isn't loaded successfully, the image will contain a "broken image" icon similar to that used in many web browsers. If you want to handle errors in loading the file yourself, for example by displaying an error message, then load the image with `gdk_pixbuf_new_from_file()`, then create the GtkImage with `gtk_image_new_from_pixbuf()`.

The image file may contain an animation, if so the GtkImage will display an animation (GdkPixbufAnimation) instead of a static image.

GtkImage is a subclass of GtkMisc, which implies that you can align it (center, left, right) and add padding to it, using GtkMisc methods.

GtkImage is a "no window" widget (has no GdkWindow of its own), so by default does not receive events. If you want to receive events on the image, such as button clicks, place the image inside a GtkEventBox, then connect to the event signals on the event box.

Example 5. Handling button press events on a GtkImage.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35

    static gboolean
    button_press_callback (GtkWidget      *event_box,
                           GdkEventButton *event,
                           gpointer        data)
    {
      g_print ("Event box clicked at coordinates %f,%f\n",
               event->x, event->y);

      /* Returning TRUE means we handled the event, so the signal
       * emission should be stopped (don't call any further
       * callbacks that may be connected). Return FALSE
       * to continue invoking callbacks.
       */
      return TRUE;
    }

    static GtkWidget*
    create_image (void)
    {
      GtkWidget *image;
      GtkWidget *event_box;

      image = gtk_image_new_from_file ("myfile.png");

      event_box = gtk_event_box_new ();

      gtk_container_add (GTK_CONTAINER (event_box), image);

      g_signal_connect (G_OBJECT (event_box),
                        "button_press_event",
                        G_CALLBACK (button_press_callback),
                        image);

      return image;
    }

When handling events on the event box, keep in mind that coordinates in the image may be different from event box coordinates due to the alignment and padding settings on the image (see GtkMisc). The simplest way to solve this is to set the alignment to 0.0 (left/top), and set the padding to zero. Then the origin of the image will be the same as the origin of the event box.

Sometimes an application will want to avoid depending on external data files, such as image files. GTK+ comes with a program to avoid this, called gdk-pixbuf-csource. This program allows you to convert an image into a C variable declaration, which can then be loaded into a GdkPixbuf using `gdk_pixbuf_new_from_inline()`.

## Functions

### gtk_image_get_icon_set ()

    void
    gtk_image_get_icon_set (GtkImage *image,
                            GtkIconSet **icon_set,
                            GtkIconSize *size);

Gets the icon set and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ICON_SET` (see `gtk_image_get_storage_type()`).

#### Parameters

image | a GtkImage |
icon_set | location to store a GtkIconSet, or `NULL`. | [out][transfer none][allow-none]
size | location to store a stock icon size, or `NULL`. | [out][allow-none][type int]

### gtk_image_get_image ()

    void
    gtk_image_get_image (GtkImage *image,
                         GdkImage **gdk_image,
                         GdkBitmap **mask);

Gets the GdkImage and mask being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_IMAGE` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned image and mask.

#### Parameters

image | a GtkImage |
gdk_image | return location for a GtkImage, or `NULL`. | [out][transfer none][allow-none]
mask | return location for a GdkBitmap, or `NULL`. | [out][transfer none][allow-none]

### gtk_image_get_pixbuf ()

    GdkPixbuf *
    gtk_image_get_pixbuf (GtkImage *image);

Gets the GdkPixbuf being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_PIXBUF` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned pixbuf.

#### Parameters

image | a GtkImage |

#### Returns

the displayed pixbuf, or `NULL` if the image is empty.

[transfer none]

### gtk_image_get_pixmap ()

    void
    gtk_image_get_pixmap (GtkImage *image,
                          GdkPixmap **pixmap,
                          GdkBitmap **mask);

Gets the pixmap and mask being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_PIXMAP` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned pixmap and mask.

#### Parameters

image | a GtkImage |
pixmap | location to store the pixmap, or `NULL`. | [out][transfer none][allow-none]
mask | location to store the mask, or `NULL`. | [out][transfer none][allow-none]

### gtk_image_get_stock ()

    void
    gtk_image_get_stock (GtkImage *image,
                         gchar **stock_id,
                         GtkIconSize *size);

Gets the stock icon name and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_STOCK` (see `gtk_image_get_storage_type()`). The returned string is owned by the GtkImage and should not be freed.

#### Parameters

image | a GtkImage |
stock_id | place to store a stock icon name, or `NULL`. | [out][transfer none][allow-none]
size | place to store a stock icon size, or `NULL`. | [out][allow-none][type int]

### gtk_image_get_animation ()

    GdkPixbufAnimation *
    gtk_image_get_animation (GtkImage *image);

Gets the GdkPixbufAnimation being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ANIMATION` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned animation.

#### Parameters

image | a GtkImage |

#### Returns

the displayed animation, or `NULL` if the image is empty.

[transfer none]

### gtk_image_get_icon_name ()

    void
    gtk_image_get_icon_name (GtkImage *image,
                             const gchar **icon_name,
                             GtkIconSize *size);

Gets the icon name and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ICON_NAME` (see `gtk_image_get_storage_type()`). The returned string is owned by the GtkImage and should not be freed.

#### Parameters

image | a GtkImage |
icon_name | place to store an icon name, or `NULL`. | [out][transfer none][allow-none]
size | place to store an icon size, or `NULL`. | [out][allow-none][type int]

Since: 2.6

### gtk_image_get_gicon ()

    void
    gtk_image_get_gicon (GtkImage *image,
                         GIcon **gicon,
                         GtkIconSize *size);

Gets the GIcon and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_GICON` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned GIcon.

#### Parameters

image | a GtkImage |
gicon | place to store a GIcon, or `NULL`. | [out][transfer none][allow-none]
size | place to store an icon size, or `NULL`. | [out][allow-none][type int]

Since: 2.14

### gtk_image_get_storage_type ()

    GtkImageType
    gtk_image_get_storage_type (GtkImage *image);

Gets the type of representation being used by the GtkImage to store image data. If the GtkImage has no image data, the return value will be `GTK_IMAGE_EMPTY`.

#### Parameters

image | a GtkImage |

#### Returns

image representation being used

### gtk_image_new_from_icon_set ()

    GtkWidget *
    gtk_image_new_from_icon_set (GtkIconSet *icon_set,
                                 GtkIconSize size);

Creates a GtkImage displaying an icon set. Sample stock sizes are GTK_ICON_SIZE_MENU, GTK_ICON_SIZE_SMALL_TOOLBAR. Instead of using this function, usually it's better to create a GtkIconFactory, put your icon sets in the icon factory, add the icon factory to the list of default factories with `gtk_icon_factory_add_default()`, and then use `gtk_image_new_from_stock()`. This will allow themes to override the icon you ship with your application.

The GtkImage does not assume a reference to the icon set; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

#### Parameters

icon_set | a GtkIconSet |
size | a stock icon size. | [type int]

#### Returns

a new GtkImage

### gtk_image_new_from_image ()

    GtkWidget *
    gtk_image_new_from_image (GdkImage *image,
                              GdkBitmap *mask);

Creates a GtkImage widget displaying a `image` with a `mask` . A GdkImage is a client-side image buffer in the pixel format of the current display. The GtkImage does not assume a reference to the image or mask; you still need to unref them if you own references. GtkImage will add its own reference rather than adopting yours.

#### Parameters

image | a GdkImage, or `NULL`. | [allow-none]
mask | a GdkBitmap, or `NULL`. | [allow-none]

#### Returns

a new GtkImage

### gtk_image_new_from_pixbuf ()

    GtkWidget *
    gtk_image_new_from_pixbuf (GdkPixbuf *pixbuf);

Creates a new GtkImage displaying `pixbuf` . The GtkImage does not assume a reference to the pixbuf; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

Note that this function just creates an GtkImage from the pixbuf. The GtkImage created will not react to state changes. Should you want that, you should use `gtk_image_new_from_icon_set()`.

#### Parameters

pixbuf | a GdkPixbuf, or `NULL`. | [allow-none]

#### Returns

a new GtkImage

### gtk_image_new_from_pixmap ()

    GtkWidget *
    gtk_image_new_from_pixmap (GdkPixmap *pixmap,
                               GdkBitmap *mask);

Creates a GtkImage widget displaying `pixmap` with a `mask` . A GdkPixmap is a server-side image buffer in the pixel format of the current display. The GtkImage does not assume a reference to the pixmap or mask; you still need to unref them if you own references. GtkImage will add its own reference rather than adopting yours.

#### Parameters

pixmap | a GdkPixmap, or `NULL`. | [allow-none]
mask | a GdkBitmap, or `NULL`. | [allow-none]

#### Returns

a new GtkImage

### gtk_image_new_from_stock ()

    GtkWidget *
    gtk_image_new_from_stock (const gchar *stock_id,
                              GtkIconSize size);

Creates a GtkImage displaying a stock icon. Sample stock icon names are GTK_STOCK_OPEN, GTK_STOCK_QUIT. Sample stock sizes are GTK_ICON_SIZE_MENU, GTK_ICON_SIZE_SMALL_TOOLBAR. If the stock icon name isn't known, the image will be empty. You can register your own stock icon names, see `gtk_icon_factory_add_default()` and `gtk_icon_factory_add()`.

#### Parameters

stock_id | a stock icon name |
size | a stock icon size. | [type int]

#### Returns

a new GtkImage displaying the stock icon

### gtk_image_new_from_animation ()

    GtkWidget *
    gtk_image_new_from_animation (GdkPixbufAnimation *animation);

Creates a GtkImage displaying the given animation. The GtkImage does not assume a reference to the animation; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

Note that the animation frames are shown using a timeout with G_PRIORITY_DEFAULT. When using animations to indicate busyness, keep in mind that the animation will only be shown if the main loop is not busy with something that has a higher priority.

#### Parameters

animation | an animation |

#### Returns

a new GtkImage widget

### gtk_image_new_from_icon_name ()

    GtkWidget *
    gtk_image_new_from_icon_name (const gchar *icon_name,
                                  GtkIconSize size);

Creates a GtkImage displaying an icon from the current icon theme. If the icon name isn't known, a "broken image" icon will be displayed instead. If the current icon theme is changed, the icon will be updated appropriately.

#### Parameters

icon_name | an icon name |
size | a stock icon size. | [type int]

#### Returns

a new GtkImage displaying the themed icon

Since: 2.6

### gtk_image_new_from_gicon ()

    GtkWidget *
    gtk_image_new_from_gicon (GIcon *icon,
                              GtkIconSize size);

Creates a GtkImage displaying an icon from the current icon theme. If the icon name isn't known, a "broken image" icon will be displayed instead. If the current icon theme is changed, the icon will be updated appropriately.

#### Parameters

icon | an icon |
size | a stock icon size. | [type int]

#### Returns

a new GtkImage displaying the themed icon

Since: 2.14

### gtk_image_set_from_icon_set ()

    void
    gtk_image_set_from_icon_set (GtkImage *image,
                                 GtkIconSet *icon_set,
                                 GtkIconSize size);

See `gtk_image_new_from_icon_set()` for details.

#### Parameters

image | a GtkImage |
icon_set | a GtkIconSet |
size | a stock icon size. | [type int]

### gtk_image_set_from_image ()

    void
    gtk_image_set_from_image (GtkImage *image,
                              GdkImage *gdk_image,
                              GdkBitmap *mask);

See `gtk_image_new_from_image()` for details.

#### Parameters

image | a GtkImage |
gdk_image | a GdkImage or `NULL`. | [allow-none]
mask | a GdkBitmap or `NULL`. | [allow-none]

### gtk_image_set_from_pixbuf ()

    void
    gtk_image_set_from_pixbuf (GtkImage *image,
                               GdkPixbuf *pixbuf);

See `gtk_image_new_from_pixbuf()` for details.

#### Parameters

image | a GtkImage |
pixbuf | a GdkPixbuf or `NULL`. | [allow-none]

### gtk_image_set_from_pixmap ()

    void
    gtk_image_set_from_pixmap (GtkImage *image,
                               GdkPixmap *pixmap,
                               GdkBitmap *mask);

See `gtk_image_new_from_pixmap()` for details.

#### Parameters

image | a GtkImage |
pixmap | a GdkPixmap or `NULL`. | [allow-none]
mask | a GdkBitmap or `NULL`. | [allow-none]

### gtk_image_set_from_stock ()

    void
    gtk_image_set_from_stock (GtkImage *image,
                              const gchar *stock_id,
                              GtkIconSize size);

See `gtk_image_new_from_stock()` for details.

#### Parameters

image | a GtkImage |
stock_id | a stock icon name |
size | a stock icon size. | [type int]

### gtk_image_set_from_animation ()

    void
    gtk_image_set_from_animation (GtkImage *image,
                                  GdkPixbufAnimation *animation);

Causes the GtkImage to display the given animation (or display nothing, if you set the animation to `NULL`).

#### Parameters

image | a GtkImage |
animation | the GdkPixbufAnimation |

### gtk_image_set_from_icon_name ()

    void
    gtk_image_set_from_icon_name (GtkImage *image,
                                  const gchar *icon_name,
                                  GtkIconSize size);

See `gtk_image_new_from_icon_name()` for details.

#### Parameters

image | a GtkImage |
icon_name | an icon name |
size | an icon size. | [type int]

Since: 2.6

### gtk_image_set_from_gicon ()

    void
    gtk_image_set_from_gicon (GtkImage *image,
                              GIcon *icon,
                              GtkIconSize size);

See `gtk_image_new_from_gicon()` for details.

#### Parameters

image | a GtkImage |
icon | an icon |
size | an icon size. | [type int]

Since: 2.14

### gtk_image_clear ()

    void
    gtk_image_clear (GtkImage *image);

Resets the image to be empty.

#### Parameters

image | a GtkImage |

Since: 2.8

### gtk_image_new ()

    GtkWidget *
    gtk_image_new (void);

Creates a new empty GtkImage widget.

#### Returns

a newly created GtkImage widget.

### gtk_image_set ()

    void
    gtk_image_set (GtkImage *image,
                   GdkImage *val,
                   GdkBitmap *mask);

`gtk_image_set` has been deprecated since version 2.0 and should not be used in newly-written code.

Use `gtk_image_set_from_image()` instead.

Sets the GtkImage.

#### Parameters

image | a GtkImage |
val | a GdkImage |
mask | a GdkBitmap that indicates which parts of the image should be transparent. |

### gtk_image_get ()

    void
    gtk_image_get (GtkImage *image,
                   GdkImage **val,
                   GdkBitmap **mask);

`gtk_image_get` has been deprecated since version 2.0 and should not be used in newly-written code.

Use `gtk_image_get_image()` instead.

Gets the GtkImage.

#### Parameters

image | a GtkImage |
val | return location for a GdkImage |
mask | a GdkBitmap that indicates which parts of the image should be transparent. |

### gtk_image_set_pixel_size ()

    void
    gtk_image_set_pixel_size (GtkImage *image,
                              gint pixel_size);

Sets the pixel size to use for named icons. If the pixel size is set to a value != -1, it is used instead of the icon size set by `gtk_image_set_from_icon_name()`.

#### Parameters

image | a GtkImage |
pixel_size | the new pixel size |

Since: 2.6

### gtk_image_get_pixel_size ()

    gint
    gtk_image_get_pixel_size (GtkImage *image);

Gets the pixel size used for named icons.

#### Parameters

image | a GtkImage |

#### Returns

the pixel size used for named icons.

Since: 2.6

## Types and Values

### struct GtkImage

    struct GtkImage;

This struct contain private data only and should be accessed by the functions below.

### enum GtkImageType

Describes the image data representation used by a GtkImage. If you want to get the image from the widget, you can only get the currently-stored representation. e.g. if the `gtk_image_get_storage_type()` returns GTK_IMAGE_PIXBUF, then you can call `gtk_image_get_pixbuf()` but not `gtk_image_get_stock()`. For empty images, you can request any storage type (call any of the "get" functions), but they will all return `NULL` values.

#### Members

GTK_IMAGE_EMPTY | there is no image displayed by the widget |
GTK_IMAGE_PIXMAP | the widget contains a GdkPixmap |
GTK_IMAGE_IMAGE | the widget contains a GdkImage |
GTK_IMAGE_PIXBUF | the widget contains a GdkPixbuf |
GTK_IMAGE_STOCK | the widget contains a stock icon name (see ???) |
GTK_IMAGE_ICON_SET | the widget contains a GtkIconSet |
GTK_IMAGE_ANIMATION | the widget contains a GdkPixbufAnimation |
GTK_IMAGE_ICON_NAME | the widget contains a named icon. This image type was added in GTK+ 2.6 |
GTK_IMAGE_GICON | the widget contains a GIcon. This image type was added in GTK+ 2.14 |

### gtk_image_new_from_file

    #define gtk_image_new_from_file gtk_image_new_from_file_utf8

Creates a new GtkImage displaying the file `filename` . If the file isn't found or can't be loaded, the resulting GtkImage will display a "broken image" icon. This function never returns `NULL`, it always returns a valid GtkImage widget.

If the file contains an animation, the image will contain an animation.

If you need to detect failures to load the file, use `gdk_pixbuf_new_from_file()` to load the file yourself, then create the GtkImage from the pixbuf. (Or for animations, use `gdk_pixbuf_animation_new_from_file()`).

The storage type (`gtk_image_get_storage_type()`) of the returned image is not defined, it will be whatever is appropriate for displaying the file.

#### Parameters

filename | a filename |

#### Returns

a new GtkImage

### gtk_image_set_from_file

    #define gtk_image_set_from_file gtk_image_set_from_file_utf8

See `gtk_image_new_from_file()` for details.

#### Parameters

image | a GtkImage |
filename | a filename or `NULL`. | [allow-none]

## Property Details

### The `“file”` property

      “file”                     gchar *

Filename to load and display.

Flags: Read / Write

Default value: NULL

### The `“gicon”` property

      “gicon”                    GIcon *

The GIcon displayed in the GtkImage. For themed icons, If the icon theme is changed, the image will be updated automatically.

Flags: Read / Write

Since: 2.14

### The `“icon-name”` property

      “icon-name”                gchar *

The name of the icon in the icon theme. If the icon theme is changed, the image will be updated automatically.

Flags: Read / Write

Default value: NULL

Since: 2.6

### The `“icon-set”` property

      “icon-set”                 GtkIconSet *

Icon set to display.

Flags: Read / Write

### The `“icon-size”` property

      “icon-size”                gint

Symbolic size to use for stock icon, icon set or named icon.

Flags: Read / Write

Allowed values: >= 0

Default value: 4

### The `“image”` property

      “image”                    GdkImage *

A GdkImage to display.

Flags: Read / Write

### The `“mask”` property

      “mask”                     GdkPixmap *

Mask bitmap to use with GdkImage or GdkPixmap.

Flags: Read / Write

### The `“pixbuf”` property

      “pixbuf”                   GdkPixbuf *

A GdkPixbuf to display.

Flags: Read / Write

### The `“pixbuf-animation”` property

      “pixbuf-animation”         GdkPixbufAnimation *

GdkPixbufAnimation to display.

Flags: Read / Write

### The `“pixel-size”` property

      “pixel-size”               gint

The "pixel-size" property can be used to specify a fixed size overriding the “icon-size” property for images of type `GTK_IMAGE_ICON_NAME`.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since: 2.6

### The `“pixmap”` property

      “pixmap”                   GdkPixmap *

A GdkPixmap to display.

Flags: Read / Write

### The `“stock”` property

      “stock”                    gchar *

Stock ID for a stock image to display.

Flags: Read / Write

Default value: NULL

### The `“storage-type”` property

      “storage-type”             GtkImageType

The representation being used for image data.

Flags: Read

Default value: GTK_IMAGE_EMPTY

## See Also

GdkPixbuf